/*
Title:      NK referenties - custom functions
Author:     Tiekstramedia, tiekstramedia.nl
*/


$(function () {
    // LOAD NAVIGATION
    $('#nav').load('nav.html #nav>.section', function(response, status, xhr) {
        if (status == "error") {
            var msg = "Sorry, de navigatie kan niet geladen worden:\n";
            alert(msg + xhr.status + " " + xhr.statusText);
        }

        $('#nav').trigger('loaded');
    });


    // AUDIO PLAYER
    // vb. html: <a href="audio/mp3/NK-5e-56v-k1-REF5-A17.mp3" data-ogg-href="audio/ogg/NK-5e-56v-k1-REF5-A17.ogg" rel="alternate" class="audio">Hallo, k&ouml;nnen Sie helfen?</a>
    var audioplayer = document.createElement('audio');

    var playAudio = function(src) {
        var href = false;

        if (audioplayer.canPlayType) {
            if (audioplayer.canPlayType('audio/mpeg') !== "") {
                // mp3 supported
                href = src.attr('href');
            } else if (audioplayer.canPlayType('audio/ogg; codecs="vorbis"') !== "" && src.data('ogg-href')) {
                // ogg supported
                href = src.data('ogg-href');
            } else {
                // no mp3 support, no ogg support or no ogg file defined
                return href;
            }
        }
        else {
            // no html5 audio support
            return href;
        }

        audioplayer.src = href;
        audioplayer.play();
        return href;
    };

    $(audioplayer).appendTo('body');

    $('[rel=alternate].audio').on('click', function(e) {
        if (playAudio($(this))) {
            e.preventDefault();
        }
    });


    // SEARCHING
    if ( getUrlParameter( 'zoek', document.location.href ) !== "") {
        var searchQuery = getUrlParameter( 'zoek', document.location.href ).replace(/^\++|\++$/g, ""),
            searchString = searchQuery.split('+').join(' ');

        if ( $('#searchResults' ).length > 0 ) {
            // search pages
            $('#nav').on('loaded', function() {
                var pages = [],
                    titles = [],
                    rawText = [],
                    bingo = [],
                    searchItems = [],
                    searchResults = $("ul#searchResults");

                // get all pages
                $('#nav .tree li a').each(function(index) {
                    pages.pushUnique( $(this).attr('href').split('.html')[0] + '.html' )
                });

                // harvest all data form pages
                for (var i = 0; i < pages.length; i++) {
                    $.ajax({
                        async: false,
                        url: pages[i],
                        context: $('#main')
                    }).done(function( data ) {
                        var title = $(data).find('#main h1').html();
                        var text =  $(data).text().replace(/\n/g, ' ').replace(/\t/g, ' ').replace(/ +(?= )/g,'').toLowerCase();

                        titles.push( title );
                        rawText.push( text );

                        bingo.push( text.split( searchString.toLowerCase() ).length > 1 );
                    });

                }

                // search data
                for (var i = 0; i < bingo.length; i++) {
                    if ( bingo[i] ) {
                        searchItems.push('<li><a href="' + pages[i] + '?zoek=' + searchQuery + '">' + titles[i] + '</a></li>');
                    }
                }

                // show results
                searchResults.html( searchItems );
                if (searchItems.length > 0) $(".notfound").hide();
            });
        } else {
            // highlight words
            $("#main").highlight( searchString );
        }

        $('#nav').on('loaded', function() {
            $("input[name=zoek]").val( decodeURI( searchString ) );
        });
    }
});

// getUrlParameter
function getUrlParameter( name, url ) {
    name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");

    var regexS = "[\\?&]"+name+"=([^&#]*)";
    var regex = new RegExp( regexS );

    var results = regex.exec( url );
    if( results == null )
        return "";
    else
        return results[1];
}

// push unique
Array.prototype.pushUnique = function (item){
    if(this.indexOf(item) == -1) {
    //if(jQuery.inArray(item, this) == -1) {
        this.push(item);
        return true;
    }
    return false;
}

/*
 * jQuery Highlight plugin
 *
 * Based on highlight v3 by Johann Burkard
 * https://johannburkard.de/blog/programming/javascript/highlight-javascript-text-higlighting-jquery-plugin.html
 *
 * Code a little bit refactored and cleaned (in my humble opinion).
 * Most important changes:
 *  - has an option to highlight only entire words (wordsOnly - false by default),
 *  - has an option to be case sensitive (caseSensitive - false by default)
 *  - highlight element tag and class names can be specified in options
 *
 * Usage:
 *   // wrap every occurrance of text 'lorem' in content
 *   // with <span class='highlight'> (default options)
 *   $('#content').highlight('lorem');
 *
 *   // search for and highlight more terms at once
 *   // so you can save some time on traversing DOM
 *   $('#content').highlight(['lorem', 'ipsum']);
 *   $('#content').highlight('lorem ipsum');
 *
 *   // search only for entire word 'lorem'
 *   $('#content').highlight('lorem', { wordsOnly: true });
 *
 *   // don't ignore case during search of term 'lorem'
 *   $('#content').highlight('lorem', { caseSensitive: true });
 *
 *   // wrap every occurrance of term 'ipsum' in content
 *   // with <em class='important'>
 *   $('#content').highlight('ipsum', { element: 'em', className: 'important' });
 *
 *   // remove default highlight
 *   $('#content').unhighlight();
 *
 *   // remove custom highlight
 *   $('#content').unhighlight({ element: 'em', className: 'important' });
 *
 *
 * Copyright (c) 2009 Bartek Szopka
 *
 * Licensed under MIT license.
 *
 */

jQuery.extend({
    highlight: function (node, re, nodeName, className) {
        if (node.nodeType === 3) {
            var match = node.data.match(re);
            if (match) {
                var highlight = document.createElement(nodeName || 'span');
                highlight.className = className || 'highlight';
                var wordNode = node.splitText(match.index);
                wordNode.splitText(match[0].length);
                var wordClone = wordNode.cloneNode(true);
                highlight.appendChild(wordClone);
                wordNode.parentNode.replaceChild(highlight, wordNode);
                return 1; //skip added node in parent
            }
        } else if ((node.nodeType === 1 && node.childNodes) && // only element nodes that have children
                !/(script|style)/i.test(node.tagName) && // ignore script and style nodes
                !(node.tagName === nodeName.toUpperCase() && node.className === className)) { // skip if already highlighted
            for (var i = 0; i < node.childNodes.length; i++) {
                i += jQuery.highlight(node.childNodes[i], re, nodeName, className);
            }
        }
        return 0;
    }
});

jQuery.fn.unhighlight = function (options) {
    var settings = { className: 'highlight', element: 'span' };
    jQuery.extend(settings, options);

    return this.find(settings.element + "." + settings.className).each(function () {
        var parent = this.parentNode;
        parent.replaceChild(this.firstChild, this);
        parent.normalize();
    }).end();
};

jQuery.fn.highlight = function (words, options) {
    var settings = { className: 'highlight', element: 'span', caseSensitive: false, wordsOnly: false };
    jQuery.extend(settings, options);

    if (words.constructor === String) {
        words = [words];
    }
    words = jQuery.grep(words, function(word, i){
      return word != '';
    });
    words = jQuery.map(words, function(word, i) {
      return word.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
    });
    if (words.length == 0) { return this; };

    var flag = settings.caseSensitive ? "" : "i";
    var pattern = "(" + words.join("|") + ")";
    if (settings.wordsOnly) {
        pattern = "\\b" + pattern + "\\b";
    }
    var re = new RegExp(pattern, flag);

    return this.each(function () {
        jQuery.highlight(this, re, settings.element, settings.className);
    });
};
